Name:           cppcheck
Summary:        Static analysis tool for C/C++
Version:        1.83
Release:        %mkrel 1
License:        GPLv3+
Group:          Development/C++
Url:            http://cppcheck.sourceforge.net/
Source:         http://downloads.sourceforge.net/sourceforge/%{name}/%{name}-%{version}.tar.xz
# See http://trac.cppcheck.net/ticket/7037
# Tests fail on i586 / 32-bit.
Patch1:         cppcheck-1.71-skip-failing-tests.patch
BuildRequires:  docbook-style-xsl
BuildRequires:  libxslt-proc
BuildRequires: libpcre0-devel
BuildRequires: libtinyxml2-devel

%description
This program tries to detect bugs that your C/C++ compiler does not
find. Cppcheck is versatile. You can check non-standard code that includes
various compiler extensions, inline assembly code, etc. One of its goals
is no false positives.

%prep
%setup -q
%apply_patches

%build
# TINYXML= prevents use of the bundled tinyxml
export CXXFLAGS="%{optflags}" LDFLAGS="%{ldflags}" LIBS="-ltinyxml2"

%make_build TINYXML= CFGDIR=%{_datadir}/%{name}

# this command line is documented inside cppcheck.1.xml
cd man
xsltproc --nonet --param man.charmap.use.subset "0" \
   --param make.year.ranges "1" --param make.single.year.ranges "1" \
   /usr/share/sgml/docbook/xsl-stylesheets/manpages/docbook.xsl \
   cppcheck.1.xml

%check
# Config is not available in the system-wide directory - delete executables and recompile
find . -name \*.o -delete
export CXXFLAGS="%{optflags} -DNDEBUG $(pcre-config --cflags)" LDFLAGS="%{ldflags}" LIBS="-ltinyxml2"

%make_build TINYXML= CFGDIR=$(pwd)/cfg check

%install
%make_install
mkdir -p %{buildroot}%{_mandir}/man1
install -m 0644 man/cppcheck.1 %{buildroot}/%{_mandir}/man1

# Taken from the Fedora 22 .src.rpm - thanks!
# Install cfg files
cd cfg
for f in *; do
    install -D -p -m 644 $f %{buildroot}%{_datadir}/cppcheck/$f
done

%files
%doc AUTHORS readme.txt
%{_bindir}/*.py
%{_bindir}/cppcheck
%{_bindir}/cppcheck-htmlreport
%{_datadir}/cppcheck/
%{_mandir}/man1/cppcheck.1*


%changelog
* Sat Oct 20 2018 adrianomorselli <adrianomorselli> 1.83-1uplos2018
- update
